package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class InstructorTest {

    @Test
    public void testImplementation(){
        Instructor newInstructor = new Instructor(111000, "Joe");
        boolean expectedOutput = true;

        boolean actualOutput = (newInstructor instanceof Teacher);

        Assert.assertTrue(actualOutput);
    }

    @Test
    public void testInheritance(){
        Instructor newInstructor = new Instructor(111000, "Joe");
        boolean expectedOutput = true;

        boolean actualOutput = (newInstructor instanceof Person);

        Assert.assertTrue(actualOutput);

    }

    @Test
    public void testTeach(){
        Instructor newInstructor = new Instructor(111000, "Mary");
        Student newStudent = new Student(111000, "Joe");
        newStudent.setTotalStudyTime(1.0);

        double expectedOutput = 2.0;

        newInstructor.teach(newStudent, 1.0);

        double actualOutput = newStudent.getTotalStudyTime();

        Assert.assertEquals(expectedOutput, actualOutput, .002);

    }

    @Test
    public void testLecture(){
        Instructor newInstructor = new Instructor(111000, "Mary");
        Student newStudent = new Student(111000, "Joe");
        newStudent.setTotalStudyTime(1.0);

        Student newStudent2 = new Student(111000, "Joe");
        newStudent2.setTotalStudyTime(1.0);

        Student[] array =  {newStudent, newStudent2};

        double expectedOutput = 2.5;

        newInstructor.lecture(array, 3.0);

        double actualOutput = newStudent2.getTotalStudyTime();

        Assert.assertEquals(expectedOutput, actualOutput, .002);

    }
}
