package io.zipcoder.interfaces;

import org.junit.Test;
import org.junit.Assert;

import java.lang.reflect.Array;
import java.util.ArrayList;

public class PeopleTest {

    People people1 = new People();
    Person person1 = new Person(11110000, "Joe");
    Person person2 = new Person(22220000,  "Joe");
    ArrayList <Person> array = new ArrayList<Person>();

    @Test
    public void addTest(){

        int expectedOutput = 2;

        people1.add(array, person1);
        people1.add(array, person2);
        int actualOutput = array.size();

        Assert.assertEquals(expectedOutput, actualOutput);
    }

    @Test
    public void removeByPersonTest(){
        int expectedOutput = 0;

        people1.removeByPerson(array, person1);
        people1.removeByPerson(array, person2);
        int actualOutput = people1.getCount(array);

        Assert.assertEquals(expectedOutput, actualOutput);

    }

    @Test
    public void removeByIdTest(){
        people1.add(array, person1);
        people1.add(array, person2);
        int expectedOutput = 1;

        people1.removeById(array, 22220000);
        int actualOutput = people1.getCount(array);

        Assert.assertEquals(expectedOutput, actualOutput);

    }

    @Test
    public void findByIdTest(){
        people1.add(array, person2);
        Person expectedOutput = person2;

        Person actualOutput = people1.findByID(array, 22220000);

        Assert.assertEquals(expectedOutput, actualOutput);
    }

//    @Test
//    public void getArrayTest(){
//        ArrayList<Person> expectedOutput = null;
//
//        ArrayList<Person> actualOutput = people1.getArray();
//
//        Assert.assertEquals(expectedOutput, actualOutput);
//    }

    @Test
    public void removeAllTest(){
        boolean expectedOutput = true;

        people1.removeAll(array);
        boolean actualOutput = array.isEmpty();

        Assert.assertTrue(actualOutput);

    }
}
